Index: /trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1355)
+++ /trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 1356)
@@ -1791,44 +1806,44 @@
 
 Void TDecTop::initFromActiveVps( const TComVPS* vps )
-{   
-  setViewId   ( vps->getViewId   ( getLayerId() )      );  
+{
+  setViewId   ( vps->getViewId   ( getLayerId() )      );
 #if NH_3D
-  setViewIndex( vps->getViewIndex( getLayerId() )      );  
-  setIsDepth  ( vps->getDepthId  ( getLayerId() ) == 1 );  
+  setViewIndex( vps->getViewIndex( getLayerId() )      );
+  setIsDepth  ( vps->getDepthId  ( getLayerId() ) == 1 );
 #endif
 
   if ( !vps->getVpsExtensionFlag() )
   {
-    m_decodingProcess = CLAUSE_8; 
+    m_decodingProcess = CLAUSE_8;
     m_isInOwnTargetDecLayerIdList = ( getLayerId() ==  0 );
   }
   else
-  {  
+  {
     if ( m_targetOlsIdx == -1 )
     {
-      // Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. ) 
-      m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1(); 
-    }
-
-    Int targetDecLayerSetIdx = vps->olsIdxToLsIdx( m_targetOlsIdx ); 
+      // Corresponds to specification by "External Means". (Should be set equal to 0, when no external means available. )
+      m_targetOlsIdx = vps->getVpsNumLayerSetsMinus1();
+    }
+
+    Int targetDecLayerSetIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
 
     if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && vps->getVpsBaseLayerInternalFlag() )
     {
-      m_smallestLayerId = 0; 
+      m_smallestLayerId = 0;
     }
     else if ( targetDecLayerSetIdx <= vps->getVpsNumLayerSetsMinus1() && !vps->getVpsBaseLayerInternalFlag() )
     {
-      m_smallestLayerId = 0; 
+      m_smallestLayerId = 0;
     }
     else if ( targetDecLayerSetIdx > vps->getVpsNumLayerSetsMinus1() && vps->getNumLayersInIdList( targetDecLayerSetIdx) == 1 )
     {
-      
-      // m_smallestLayerId = 0;       
-      // For now don't do change of layer id here. 
-      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+
+      // m_smallestLayerId = 0;
+      // For now don't do change of layer id here.
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];
     }
     else
     {
-      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];    
+      m_smallestLayerId = vps->getTargetDecLayerIdList( targetDecLayerSetIdx )[ 0 ];
     }
 
@@ -1836,19 +1851,19 @@
     // Set profile
     Int lsIdx = vps->olsIdxToLsIdx( m_targetOlsIdx );
-    Int lIdx = -1; 
+    Int lIdx = -1;
     for (Int j = 0; j < vps->getNumLayersInIdList( lsIdx ) ; j++ )
     {
       if ( vps->getLayerSetLayerIdList( lsIdx, j ) == getLayerId() )
-      {        
-        lIdx = j;         
-        break; 
-      }        
-    }
-    m_isInOwnTargetDecLayerIdList = (lIdx != -1); 
+      {
+        lIdx = j;
+        break;
+      }
+    }
+    m_isInOwnTargetDecLayerIdList = (lIdx != -1);
 
     if ( m_isInOwnTargetDecLayerIdList )
     {
       Int profileIdc = vps->getPTL( vps->getProfileTierLevelIdx( m_targetOlsIdx, lIdx ) )->getGeneralPTL()->getProfileIdc();
-      assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 ); 
+      assert( profileIdc == 1 || profileIdc == 6 || profileIdc == 8 );
 
       if (  profileIdc == 6 )
@@ -1881,41 +1896,41 @@
 
   //  Output of this process is PicOrderCntVal, the picture order count of the current picture.
-  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and
   //  motion vector prediction, and for decoder conformance checking (see clause C.5).
   //  Each coded picture is associated with a picture order count variable, denoted as PicOrderCntVal.
 
-  const TComSlice* curSlice = m_pcPic->getSlice(0); 
-
-  Int prevPicOrderCntLsb = MIN_INT; 
-  Int prevPicOrderCntMsb = MIN_INT;  
-  if (!(m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag() )  )  
-  {
-    //  When the current picture is not an IRAP picture with NoRaslOutputFlag equal to 1, 
+  const TComSlice* curSlice = m_pcPic->getSlice(0);
+
+  Int prevPicOrderCntLsb = MIN_INT;
+  Int prevPicOrderCntMsb = MIN_INT;
+  if (!(m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag() )  )
+  {
+    //  When the current picture is not an IRAP picture with NoRaslOutputFlag equal to 1,
     //  the variables prevPicOrderCntLsb and prevPicOrderCntMsb are derived as follows:
 
-    //  -  Let prevTid0Pic be the previous picture in decoding order that has TemporalId equal to 0 and that is not a RASL picture, 
+    //  -  Let prevTid0Pic be the previous picture in decoding order that has TemporalId equal to 0 and that is not a RASL picture,
     //     a RADL picture or an SLNR picture.
 
     //  -  The variable prevPicOrderCntLsb is set equal to slice_pic_order_cnt_lsb of prevTid0Pic.
-    prevPicOrderCntLsb = m_prevTid0PicSlicePicOrderCntLsb; 
+    prevPicOrderCntLsb = m_prevTid0PicSlicePicOrderCntLsb;
 
     //  -  The variable prevPicOrderCntMsb is set equal to PicOrderCntMsb of prevTid0Pic.
-    prevPicOrderCntMsb = m_prevTid0PicPicOrderCntMsb; 
-  }
-
-  //  The variable PicOrderCntMsb of the current picture is derived as follows:  
-  
+    prevPicOrderCntMsb = m_prevTid0PicPicOrderCntMsb;
+  }
+
+  //  The variable PicOrderCntMsb of the current picture is derived as follows:
+
   Int slicePicOrderCntLsb = curSlice->getSlicePicOrderCntLsb();
 
-  Int picOrderCntMsb; 
+  Int picOrderCntMsb;
 
   if (m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag()  )
   {
     //-  If the current picture is an IRAP picture with NoRaslOutputFlag equal to 1, PicOrderCntMsb is set equal to 0.
-    picOrderCntMsb = 0; 
+    picOrderCntMsb = 0;
   }
   else
   {
-    Int maxPicOrderCntLsb   = curSlice->getSPS()->getMaxPicOrderCntLsb(); 
+    Int maxPicOrderCntLsb   = curSlice->getSPS()->getMaxPicOrderCntLsb();
 
   //  -  Otherwise, PicOrderCntMsb is derived as follows:
@@ -1933,15 +1948,15 @@
     else
     {
-      picOrderCntMsb = prevPicOrderCntMsb; 
-    }
-  }
-  
+      picOrderCntMsb = prevPicOrderCntMsb;
+    }
+  }
+
   //PicOrderCntVal is derived as follows:
   Int picOrderCntVal = picOrderCntMsb + slicePicOrderCntLsb; //   (8 2)
 
-  //  NOTE 1 - All IDR pictures will have PicOrderCntVal equal to 0 since slice_pic_order_cnt_lsb is inferred to be 0 for IDR 
+  //  NOTE 1 - All IDR pictures will have PicOrderCntVal equal to 0 since slice_pic_order_cnt_lsb is inferred to be 0 for IDR
   //  pictures and prevPicOrderCntLsb and prevPicOrderCntMsb are both set equal to 0.
 
-  m_pcPic->getSlice(0)->setPOC( picOrderCntVal ); 
+  m_pcPic->getSlice(0)->setPOC( picOrderCntVal );
 
   // Update prevTid0Pic
@@ -1949,6 +1964,6 @@
   if( curSlice->getTemporalId() == 0  && !m_pcPic->isRasl() && !m_pcPic->isRadl() && !m_pcPic->isSlnr() )
   {
-    m_prevTid0PicSlicePicOrderCntLsb = slicePicOrderCntLsb;     
-    m_prevTid0PicPicOrderCntMsb      = picOrderCntMsb;  
+    m_prevTid0PicSlicePicOrderCntLsb = slicePicOrderCntLsb;
+    m_prevTid0PicPicOrderCntMsb      = picOrderCntMsb;
   }
 }
@@ -1957,42 +1972,42 @@
 {
   //Output of this process is PicOrderCntVal, the picture order count of the current picture.
-  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and 
+  //  Picture order counts are used to identify pictures, for deriving motion parameters in merge mode and
   //  motion vector prediction and for decoder conformance checking (see clause F.13.5).
 
   //  Each coded picture is associated with a picture order count variable, denoted as PicOrderCntVal.
 
-  const TComSlice* slice = m_pcPic->getSlice(0); 
-  const Int nuhLayerId   = m_pcPic->getLayerId(); 
-  const TComVPS*   vps   = slice->getVPS(); 
-  const TComSPS*   sps   = slice->getSPS(); 
+  const TComSlice* slice = m_pcPic->getSlice(0);
+  const Int nuhLayerId   = m_pcPic->getLayerId();
+  const TComVPS*   vps   = slice->getVPS();
+  const TComSPS*   sps   = slice->getSPS();
   if ( m_pcPic->getIsFstPicOfAllLayOfPocResetPer() )
   {
-    //  When the current picture is the first picture among all layers of a POC resetting period, 
+    //  When the current picture is the first picture among all layers of a POC resetting period,
     //  the variable PocDecrementedInDPBFlag[ i ] is set equal to 0 for each value of i in the range of 0 to 62, inclusive.
     for (Int i = 0; i <= 62; i++)
     {
-      m_pocDecrementedInDpbFlag[ i ] = 0; 
+      m_pocDecrementedInDpbFlag[ i ] = 0;
     }
   }
 
   //  The variable pocResettingFlag is derived as follows:
-  Bool pocResettingFlag; 
+  Bool pocResettingFlag;
   if (m_pcPic->getIsPocResettingPic() )
   {
-    //-  If the current picture is a POC resetting picture, the following applies:    
+    //-  If the current picture is a POC resetting picture, the following applies:
     if( vps->getVpsPocLsbAlignedFlag()  )
     {
       //  -  If vps_poc_lsb_aligned_flag is equal to 0, pocResettingFlag is set equal to 1.
-      pocResettingFlag = true; 
+      pocResettingFlag = true;
     }
     else if ( m_pocDecrementedInDpbFlag[ nuhLayerId ] )
     {
       //  -  Otherwise, if PocDecrementedInDPBFlag[ nuh_layer_id ] is equal to 1, pocResettingFlag is set equal to 0.
-      pocResettingFlag = false; 
+      pocResettingFlag = false;
     }
     else
     {
       //  -  Otherwise, pocResettingFlag is set equal to 1.
-      pocResettingFlag = true; 
+      pocResettingFlag = true;
     }
   }
@@ -2000,21 +2015,21 @@
   {
     //  -  Otherwise, pocResettingFlag is set equal to 0.
-    pocResettingFlag = false; 
+    pocResettingFlag = false;
   }
 
   //  The list affectedLayerList is derived as follows:
-  std::vector<Int> affectedLayerList; 
+  std::vector<Int> affectedLayerList;
   if (! vps->getVpsPocLsbAlignedFlag() )
   {
     //-  If vps_poc_lsb_aligned_flag is equal to 0, affectedLayerList consists of the nuh_layer_id of the current picture.
-    affectedLayerList.push_back( nuhLayerId ); 
+    affectedLayerList.push_back( nuhLayerId );
   }
   else
   {
-    //  -  Otherwise, affectedLayerList consists of the nuh_layer_id of the current picture and the nuh_layer_id values 
-    //     equal to IdPredictedLayer[ currNuhLayerId ][ j ] for all values of j in the range of 0 to NumPredictedLayers[ currNuhLayerId ] - 1, 
+    //  -  Otherwise, affectedLayerList consists of the nuh_layer_id of the current picture and the nuh_layer_id values
+    //     equal to IdPredictedLayer[ currNuhLayerId ][ j ] for all values of j in the range of 0 to NumPredictedLayers[ currNuhLayerId ] - 1,
     //     inclusive, where currNuhLayerId is the nuh_layer_id value of the current picture.
-    affectedLayerList.push_back( nuhLayerId ); 
-    Int currNuhLayerId = nuhLayerId; 
+    affectedLayerList.push_back( nuhLayerId );
+    Int currNuhLayerId = nuhLayerId;
     for (Int j = 0; j <= vps->getNumPredictedLayers( currNuhLayerId )-1; j++ )
     {
@@ -2022,7 +2037,7 @@
     }
   }
-  
-  Int picOrderCntMsb; 
-  Int picOrderCntVal; 
+
+  Int picOrderCntMsb;
+  Int picOrderCntVal;
 
   //  Depending on pocResettingFlag, the following applies:
@@ -2033,20 +2048,20 @@
     {
       //-  The variables pocMsbDelta, pocLsbDelta and DeltaPocVal are derived as follows:
-      Int pocMsbDelta; 
-      Int pocLsbDelta; 
-      Int deltaPocVal;       
-
-      {
-        Int pocLsbVal; 
-        Int prevPicOrderCntLsb; 
-        Int prevPicOrderCntMsb; 
+      Int pocMsbDelta;
+      Int pocLsbDelta;
+      Int deltaPocVal;
+
+      {
+        Int pocLsbVal;
+        Int prevPicOrderCntLsb;
+        Int prevPicOrderCntMsb;
 
         if( slice->getPocResetIdc() ==  3 )
         {
-          pocLsbVal = slice->getPocLsbVal(); 
-        }      
+          pocLsbVal = slice->getPocLsbVal();
+        }
         else
         {
-          pocLsbVal = slice->getSlicePicOrderCntLsb(); 
+          pocLsbVal = slice->getSlicePicOrderCntLsb();
         }
 
@@ -2054,25 +2069,25 @@
         {
           pocMsbDelta = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb();   // (F 60)
-        }      
-        else
-        {
-          prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 ); 
-          prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
-
-          pocMsbDelta = xGetCurrMsb( pocLsbVal, prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
-        }
-
-        if( slice->getPocResetIdc() == 2 ||  ( slice->getPocResetIdc() == 3  &&  slice->getFullPocResetFlag() ) )
-        {
-          pocLsbDelta = pocLsbVal; 
         }
         else
         {
-          pocLsbDelta = 0; 
+          prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 );
+          prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb;
+
+          pocMsbDelta = xGetCurrMsb( pocLsbVal, prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() );
         }
-        deltaPocVal = pocMsbDelta + pocLsbDelta; 
-      }
-
-      //-  The PicOrderCntVal of each picture that has nuh_layer_id value nuhLayerId for which PocDecrementedInDPBFlag[ nuhLayerId ] is equal to 0 
+
+        if( slice->getPocResetIdc() == 2 ||  ( slice->getPocResetIdc() == 3  &&  slice->getFullPocResetFlag() ) )
+        {
+          pocLsbDelta = pocLsbVal;
+        }
+        else
+        {
+          pocLsbDelta = 0;
+        }
+        deltaPocVal = pocMsbDelta + pocLsbDelta;
+      }
+
+      //-  The PicOrderCntVal of each picture that has nuh_layer_id value nuhLayerId for which PocDecrementedInDPBFlag[ nuhLayerId ] is equal to 0
       //   and that is equal to any value in affectedLayerList is decremented by DeltaPocVal.
       for (Int i = 0; i < (Int) affectedLayerList.size(); i++ )
@@ -2080,5 +2095,5 @@
         if ( !m_pocDecrementedInDpbFlag[ affectedLayerList[i] ] )
         {
-          m_dpb->decrementPocsInSubDpb( affectedLayerList[i], deltaPocVal ); 
+          m_dpb->decrementPocsInSubDpb( affectedLayerList[i], deltaPocVal );
         }
       }
@@ -2087,21 +2102,21 @@
       for (Int i = 0; i < (Int) affectedLayerList.size(); i++ )
       {
-        m_pocDecrementedInDpbFlag[ affectedLayerList[i] ] = true; 
-      }
-    } 
+        m_pocDecrementedInDpbFlag[ affectedLayerList[i] ] = true;
+      }
+    }
 
     //-  The PicOrderCntVal of the current picture is derived as follows:
     if( slice->getPocResetIdc()  ==  1 )
     {
-      picOrderCntVal = slice->getSlicePicOrderCntLsb(); 
-    }
-    else if (slice->getPocResetIdc()  ==  2 ) 
-    {
-      picOrderCntVal = 0; 
+      picOrderCntVal = slice->getSlicePicOrderCntLsb();
+    }
+    else if (slice->getPocResetIdc()  ==  2 )
+    {
+      picOrderCntVal = 0;
     }
     else
     {
-       picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() ); 
-       picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
+       picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal(), 0, sps->getMaxPicOrderCntLsb() );
+       picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb();
     }
   }
@@ -2110,8 +2125,8 @@
     //-  Otherwise (pocResettingFlag is equal to 0), the following applies:
     //-  The PicOrderCntVal of the current picture is derived as follows:
-    
+
     if( slice->getPocMsbCycleValPresentFlag() )
     {
-      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb(); 
+      picOrderCntMsb = slice->getPocMsbCycleVal() * sps->getMaxPicOrderCntLsb();
     }
     else if( !m_firstPicInLayerDecodedFlag[ nuhLayerId ]  ||
@@ -2119,29 +2134,29 @@
     {
       picOrderCntMsb = 0; //     (F 62)
-    }    
+    }
     else
     {
         Int prevPicOrderCntLsb = m_prevPicOrderCnt & ( sps->getMaxPicOrderCntLsb() - 1 );
-        Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb; 
-        picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() ); 
-    }
-    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb(); 
-  }
-  
-  m_pcPic->getSlice(0)->setPOC( picOrderCntVal ); 
-  
+        Int prevPicOrderCntMsb = m_prevPicOrderCnt - prevPicOrderCntLsb;
+        picOrderCntMsb = xGetCurrMsb( slice->getSlicePicOrderCntLsb(), prevPicOrderCntLsb, prevPicOrderCntMsb, sps->getMaxPicOrderCntLsb() );
+    }
+    picOrderCntVal = picOrderCntMsb + slice->getSlicePicOrderCntLsb();
+  }
+
+  m_pcPic->getSlice(0)->setPOC( picOrderCntVal );
+
   for (Int lId = 0; lId < (Int) affectedLayerList.size(); lId++ )
-  {  
+  {
     //  The value of PrevPicOrderCnt[ lId ] for each of the lId values included in affectedLayerList is derived as follows:
 
     if (!m_pcPic->isRasl() && !m_pcPic->isRadl() && !m_pcPic->isSlnr() && slice->getTemporalId() == 0 && !slice->getDiscardableFlag() )
     {
-      //-  If the current picture is not a RASL picture, a RADL picture or a sub-layer non-reference picture, and the current picture 
+      //-  If the current picture is not a RASL picture, a RADL picture or a sub-layer non-reference picture, and the current picture
       //   has TemporalId equal to 0 and discardable_flag equal to 0, PrevPicOrderCnt[ lId ] is set equal to PicOrderCntVal.
-      m_prevPicOrderCnt = picOrderCntVal; 
+      m_prevPicOrderCnt = picOrderCntVal;
     }
     else if ( slice->getPocResetIdc() == 3 &&  (
-      ( !m_firstPicInLayerDecodedFlag[ nuhLayerId ]) || 
-      ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] && m_pcPic->getIsPocResettingPic() ) 
+      ( !m_firstPicInLayerDecodedFlag[ nuhLayerId ]) ||
+      ( m_firstPicInLayerDecodedFlag[ nuhLayerId ] && m_pcPic->getIsPocResettingPic() )
       ) )
     {
@@ -2149,5 +2164,5 @@
       //     -  FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 0.
       //     -  FirstPicInLayerDecodedFlag[ nuh_layer_id ] is equal to 1 and the current picture is a POC resetting picture.
-      m_prevPicOrderCnt = ( slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal() ); 
+      m_prevPicOrderCnt = ( slice->getFullPocResetFlag() ? 0 : slice->getPocLsbVal() );
     }
   }
@@ -2156,5 +2171,5 @@
 Int TDecTop::xGetCurrMsb( Int cl, Int pl, Int pm, Int ml )
 {
-  Int currMsb; 
+  Int currMsb;
   if ((pl - cl) >= (ml/ 2))
   {
@@ -2163,13 +2178,13 @@
   else if ( (cl - pl) > (ml / 2))
   {
-    currMsb = pm - ml; 
+    currMsb = pm - ml;
   }
   else
   {
-    currMsb = pm; 
-  }
-
-  return currMsb;  
-}   
+    currMsb = pm;
+  }
+
+  return currMsb;
+}
 
 
@@ -2181,30 +2196,30 @@
   ///////////////////////////////////////////////////////////////////////////////////////
 
-  TComSlice* slice = m_pcPic->getSlice( 0 ); 
-  const TComSPS* sps = slice->getSPS(); 
-  //  This process is invoked once per picture, after decoding of a slice header but prior to the decoding of any coding unit and prior 
-  //  to the decoding process for reference picture list construction for the slice as specified in clause 8.3.3. 
-  //  This process may result in one or more reference pictures in the DPB being marked as "unused for reference" or 
+  TComSlice* slice = m_pcPic->getSlice( 0 );
+  const TComSPS* sps = slice->getSPS();
+  //  This process is invoked once per picture, after decoding of a slice header but prior to the decoding of any coding unit and prior
+  //  to the decoding process for reference picture list construction for the slice as specified in clause 8.3.3.
+  //  This process may result in one or more reference pictures in the DPB being marked as "unused for reference" or
   //  "used for long-term reference".
 
   // The variable currPicLayerId is set equal to nuh_layer_id of the current picture.
-  Int currPicLayerId = m_pcPic->getLayerId(); 
-  Int picOrderCntVal = m_pcPic->getPOC(); 
+  Int currPicLayerId = m_pcPic->getLayerId();
+  Int picOrderCntVal = m_pcPic->getPOC();
 
   if (m_pcPic->isIrap() && m_pcPic->getNoRaslOutputFlag()  )
-  {     
-    // When the current picture is an IRAP picture with NoRaslOutputFlag equal to 1, 
-    // all reference pictures with nuh_layer_id equal to currPicLayerId currently in the 
+  {
+    // When the current picture is an IRAP picture with NoRaslOutputFlag equal to 1,
+    // all reference pictures with nuh_layer_id equal to currPicLayerId currently in the
     // DPB (if any) are marked as "unused for reference".
-    m_dpb->markSubDpbAsUnusedForReference( currPicLayerId ); 
-  }
-  // Short-term reference pictures are identified by their PicOrderCntVal values. Long-term reference pictures are identified either by 
+    m_dpb->markSubDpbAsUnusedForReference( currPicLayerId );
+  }
+  // Short-term reference pictures are identified by their PicOrderCntVal values. Long-term reference pictures are identified either by
   // their PicOrderCntVal values or their slice_pic_order_cnt_lsb values.
 
-  // Five lists of picture order count values are constructed to derive the RPS. These five lists are PocStCurrBefore, 
-  // PocStCurrAfter, PocStFoll, PocLtCurr and PocLtFoll, with NumPocStCurrBefore, NumPocStCurrAfter, NumPocStFoll, 
+  // Five lists of picture order count values are constructed to derive the RPS. These five lists are PocStCurrBefore,
+  // PocStCurrAfter, PocStFoll, PocLtCurr and PocLtFoll, with NumPocStCurrBefore, NumPocStCurrAfter, NumPocStFoll,
   // NumPocLtCurr and NumPocLtFoll number of elements, respectively. The five lists and the five variables are derived as follows:
-  
-  TComDecodedRps* decRps = m_pcPic->getDecodedRps(); 
+
+  TComDecodedRps* decRps = m_pcPic->getDecodedRps();
 
   std::vector<Int>& pocStCurrBefore = decRps->m_pocStCurrBefore;
@@ -2214,16 +2229,16 @@
   std::vector<Int>& pocLtFoll       = decRps->m_pocLtFoll;
 
-  Int& numPocStCurrBefore = decRps->m_numPocStCurrBefore; 
+  Int& numPocStCurrBefore = decRps->m_numPocStCurrBefore;
   Int& numPocStCurrAfter  = decRps->m_numPocStCurrAfter;
   Int& numPocStFoll       = decRps->m_numPocStFoll;
   Int& numPocLtCurr       = decRps->m_numPocLtCurr;
-  Int& numPocLtFoll       = decRps->m_numPocLtFoll;   
-
-  std::vector<Int> currDeltaPocMsbPresentFlag, follDeltaPocMsbPresentFlag; 
+  Int& numPocLtFoll       = decRps->m_numPocLtFoll;
+
+  std::vector<Int> currDeltaPocMsbPresentFlag, follDeltaPocMsbPresentFlag;
 
   if (m_pcPic->isIdr() )
   {
-    // - If the current picture is an IDR picture, PocStCurrBefore, PocStCurrAfter, PocStFoll, 
-    //   PocLtCurr and PocLtFoll are all set to be empty, and NumPocStCurrBefore, 
+    // - If the current picture is an IDR picture, PocStCurrBefore, PocStCurrAfter, PocStFoll,
+    //   PocLtCurr and PocLtFoll are all set to be empty, and NumPocStCurrBefore,
     //   NumPocStCurrAfter, NumPocStFoll, NumPocLtCurr and NumPocLtFoll are all set equal to 0.
 
@@ -2233,9 +2248,9 @@
     pocLtCurr      .clear();
     pocLtFoll      .clear();
-    numPocStCurrBefore = 0; 
-    numPocStCurrAfter  = 0; 
-    numPocStFoll       = 0; 
-    numPocLtCurr       = 0; 
-    numPocLtFoll       = 0; 
+    numPocStCurrBefore = 0;
+    numPocStCurrAfter  = 0;
+    numPocStFoll       = 0;
+    numPocLtCurr       = 0;
+    numPocLtFoll       = 0;
   }
   else
@@ -2244,6 +2259,6 @@
     // -  Otherwise, the following applies:
 
-    Int j = 0; 
-    Int k = 0; 
+    Int j = 0;
+    Int k = 0;
     for( Int i = 0; i < stRps->getNumNegativePicsVar() ; i++ )
     {
@@ -2257,12 +2272,12 @@
       }
     }
-    numPocStCurrBefore = j;    
-
-    j = 0; 
+    numPocStCurrBefore = j;
+
+    j = 0;
     for (Int i = 0; i < stRps->getNumPositivePicsVar(); i++ )
     {
       if (stRps->getUsedByCurrPicS1Var( i ) )
       {
-        pocStCurrAfter.push_back( picOrderCntVal + stRps->getDeltaPocS1Var( i ) ); j++; 
+        pocStCurrAfter.push_back( picOrderCntVal + stRps->getDeltaPocS1Var( i ) ); j++;
       }
       else
@@ -2275,9 +2290,9 @@
 
 
-    j = 0; 
-    k = 0; 
+    j = 0;
+    k = 0;
     for( Int i = 0; i < slice->getNumLongTermSps( ) + slice->getNumLongTermPics(); i++ )
     {
-      Int pocLt = slice->getPocLsbLtVar( i ); 
+      Int pocLt = slice->getPocLsbLtVar( i );
       if( slice->getDeltaPocMsbPresentFlag( i ) )
       {
@@ -2286,13 +2301,13 @@
       }
 
-      if( slice->getUsedByCurrPicLtVar(i)) 
+      if( slice->getUsedByCurrPicLtVar(i))
       {
         pocLtCurr.push_back( pocLt );
-        currDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); j++; 
-      } 
+        currDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); j++;
+      }
       else
       {
         pocLtFoll.push_back( pocLt );
-        follDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); k++; 
+        follDeltaPocMsbPresentFlag.push_back( slice->getDeltaPocMsbPresentFlag( i ) ); k++;
       }
     }
@@ -2303,23 +2318,23 @@
   assert(numPocStCurrAfter  == pocStCurrAfter   .size() );
   assert(numPocStCurrBefore == pocStCurrBefore  .size() );
-  assert(numPocStFoll       == pocStFoll        .size() );  
-  assert(numPocLtCurr       == pocLtCurr        .size() );  
+  assert(numPocStFoll       == pocStFoll        .size() );
+  assert(numPocLtCurr       == pocLtCurr        .size() );
   assert(numPocLtFoll       == pocLtFoll        .size() );
 
   // where PicOrderCntVal is the picture order count of the current picture as specified in clause 8.3.1.
 
-  //   NOTE 2 - A value of CurrRpsIdx in the range of 0 to num_short_term_ref_pic_sets - 1, inclusive, 
-  //   indicates that a candidate short-term RPS from the active SPS for the current layer is being used, 
-  //   where CurrRpsIdx is the index of the candidate short-term RPS into the list of candidate short-term RPSs signalled 
-  //   in the active SPS for the current layer. CurrRpsIdx equal to num_short_term_ref_pic_sets indicates that 
+  //   NOTE 2 - A value of CurrRpsIdx in the range of 0 to num_short_term_ref_pic_sets - 1, inclusive,
+  //   indicates that a candidate short-term RPS from the active SPS for the current layer is being used,
+  //   where CurrRpsIdx is the index of the candidate short-term RPS into the list of candidate short-term RPSs signalled
+  //   in the active SPS for the current layer. CurrRpsIdx equal to num_short_term_ref_pic_sets indicates that
   //   the short-term RPS of the current picture is directly signalled in the slice header.
 
   for (Int i = 0; i <= numPocLtCurr - 1; i++  )
   {
-      // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 1, 
+      // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 1,
       // it is a requirement of bitstream conformance that the following conditions apply:
     if ( currDeltaPocMsbPresentFlag[i] )
     {
-      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive,
       //    for which PocLtCurr[ i ] is equal to PocStCurrBefore[ j ].
       for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
@@ -2328,6 +2343,6 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive, 
-      //    for which PocLtCurr[ i ] is equal to PocStCurrAfter[ j ]. 
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive,
+      //    for which PocLtCurr[ i ] is equal to PocStCurrAfter[ j ].
       for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
       {
@@ -2335,5 +2350,5 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive,
       //    for which PocLtCurr[ i ] is equal to PocStFoll[ j ].
       for (Int j = 0; j <= numPocStFoll - 1; j++ )
@@ -2342,10 +2357,10 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive,
       //    where j is not equal to i, for which PocLtCurr[ i ] is equal to PocLtCurr[ j ].
       for (Int j = 0; j <= numPocLtCurr - 1; j++ )
       {
         if ( i != j )
-        {        
+        {
           assert(!( pocLtCurr[ i ] == pocLtCurr[ j ] ) );
         }
@@ -2356,9 +2371,9 @@
   for (Int i = 0; i <= numPocLtFoll - 1; i++  )
   {
-    // For each i in the range of 0 to NumPocLtFoll - 1, inclusive, when FollDeltaPocMsbPresentFlag[ i ] is equal to 1, 
+    // For each i in the range of 0 to NumPocLtFoll - 1, inclusive, when FollDeltaPocMsbPresentFlag[ i ] is equal to 1,
     // it is a requirement of bitstream conformance that the following conditions apply:
     if ( follDeltaPocMsbPresentFlag[i] )
     {
-      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive,
       //    for which PocLtFoll[ i ] is equal to PocStCurrBefore[ j ].
       for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
@@ -2367,5 +2382,5 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStCurrAfter - 1, inclusive,
       //    for which PocLtFoll[ i ] is equal to PocStCurrAfter[ j ].
       for (Int j = 0; j <= numPocStCurrAfter - 1; j++ )
@@ -2374,5 +2389,5 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStFoll - 1, inclusive,
       //    for which PocLtFoll[ i ] is equal to PocStFoll[ j ].
       for (Int j = 0; j <= numPocStFoll - 1; j++ )
@@ -2381,5 +2396,5 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocLtFoll - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocLtFoll - 1, inclusive,
       //    where j is not equal to i, for which PocLtFoll[ i ] is equal to PocLtFoll[ j ].
       for (Int j = 0; j <= numPocLtFoll - 1; j++ )
@@ -2391,5 +2406,5 @@
       }
 
-      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocLtCurr - 1, inclusive,
       //    for which PocLtFoll[ i ] is equal to PocLtCurr[ j ].
       for (Int j = 0; j <= numPocLtCurr - 1; j++ )
@@ -2400,12 +2415,12 @@
   }
 
-  Int maxPicOrderCntLsb = sps->getMaxPicOrderCntLsb(); 
+  Int maxPicOrderCntLsb = sps->getMaxPicOrderCntLsb();
   for (Int i = 0; i <= numPocLtCurr - 1; i++  )
   {
-    // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 0, 
+    // For each i in the range of 0 to NumPocLtCurr - 1, inclusive, when CurrDeltaPocMsbPresentFlag[ i ] is equal to 0,
     // it is a requirement of bitstream conformance that the following conditions apply:
     if ( currDeltaPocMsbPresentFlag[ i ] == 0  )
     {
-      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive, 
+      // -  There shall be no j in the range of 0 to NumPocStCurrBefore - 1, inclusive,
       //    for which PocLtCurr[ i ] is equal to ( PocStCurrBefore[ j ] & ( MaxPicOrderCntLsb - 1 ) ).
       for (Int j = 0; j <= numPocStCurrBefore - 1; j++ )
